#!/usr/bin/env python
# -*- coding: koi8-r -*-
"""ALDC Moin-Moin writer"""

import metalexer
Type=("moin",("moin","Moin","MOIN","moin-moin","Moin-moin","MOIN-MOIN"),"ALDC Moin-Moin Writer",0.00,0.03)
def quote(string):
  return string.replace(":","_")

# TODO how to use &html-character; ? (aka HTMLize)


def F1_vid(*args):
  ret=args[2]["_"]%quote(args[1])
  return ret

def F1_intlink(*args):
  ret=args[2]["_"]%(quote(args[2]["linkid"].replace(" ","%20")),args[2]["group"])
  return ret

def F1_m_k(*args):
  fn=args[0].genfootnotes()
  ret='%s'%(fn and "\n-----\n%s"%fn or '')
  return ret

def F1_link(*args):
  ret=args[2]["group"] and (args[2]["_"]%(args[2]["url"],args[2]["group"])) or ("[%s]"%args[2]["url"])
  return ret

def F1_biblio(*args):
  ret=args[2]["_"]%args[2]["bid"]
  return ret

def F1_stitle(*args):
  ret=args[2]["_"]%(args[1],args[1])
  return ret

def F1_keyword(*args):
  ret=args[2]["_"]%(args[2]["glossitem"],args[2]["group"])
  return ret

def F1_verb(*args):
  ret=args[2]["_"]%(args[2]["vid"],args[2]["vbody"],args[2]["vtitle"])
  return ret

def F1_footnote(*args):
  ret=args[2]["_"]%(args[2]["$"],args[2]["$"],args[2]["$"])
  return ret

def F1_ditem(*args):
  ret=args[2]["_"]%(args[2]["term"],args[2]["defbody"])
  return ret

def F1_id(*args):
  ret=args[2]["_"]%quote(args[1])
  return ret

def F1_oid(*args):
  ret=args[2]["_"]%quote(args[1])
  return ret

def F1_object(*args):
  ret=args[2]["_"]%(args[2]["oid"],args[2]["opath"],args[2]["otitle"])
  return ret

def F1_ptitle(*args):
  ret=args[2]["_"]%(args[1],args[1])
  return ret

lexer={
"vid":	# verbatim ID
(
	"format",
	"IntId%s",
	F1_vid,
),
"primary":	# glossary primary term
(
	'',
	"'''",
	"'''",
),
"opath":	# object path
(
	'filetype',
	'',
	'',
),
"nbsp":	# punctuation: non-breakable space
(
	"replace",
	" ",
	'',
),
"table":	# NONE
(
	'',
	'',
	'',
),
"secondaries":	# glossary secondary block
(
	'delete >>',
	'',
	'',
),
"intlink":	# in-text link
(
	'< > format',
	'[#%s %s]',
	F1_intlink,
),
"deflist":	# definition list enclosure
(
	'',
	'\n',
	'',
),
"group":	# generic groupong
(
	'',
	'',
	'',
),
"quoted":	# quoted enclosure
(
	'< >',
	'"',
	'"',
),
"lllitem":	# list 3rd level item enclosure
(
	'',
	'\n      * ',
	'',
),
"glossarticle":	# glossary definition itself
(
	'',
	'||',
	'||',
),
"system":	# system enclosure
(
	'< >',
	'{{{',
	'}}}',
),
"mark":	# NONE
(
	'',
	'',
	'',
),
"error":	# red mark enclosure
(
	'>>',
	" /!\\ '''",
	"''' /!\\ ",
),
"ndash":	# En-dash
(
	'',
	'',
	'--',
),
"dots":	# int-text three dots
(
	'>',
	'',
	'...',
),
"m_k":	# A document
(
	'< >',
	'',
	F1_m_k,
),
"defbody":	# definition list item body
(
	'',
	'',
	'',
),
"para":	# paragraph
(
	'',
	'\n',
	'\n',
),
"bid":	# bibliographical ID
(
	'',
	'',
	'',
),
"repl":	# in-text replaceable
(
	'< >',
	"''`",
	"`''",
),
"link":	# link enclosure
(
	'< > format',
	'[%s %s]',
	F1_link,
),
"hl":	# in-text word highlighted part
(
	'',
	"'''",
	"'''",
),
"biblio":	# bibliographical link
(
	'format',
	'[%s]',
	F1_biblio,
),
"litem":	# list 1st level item enclosure
(
	'',
	'\n * ',
	'',
),
"secondary":	# glossary secondary term
(
	'',
	'',
	'',
),
"info":	# marginale enclosure
(
	'',
	'\n----~+',
	'+~----',
),
"stitle":	# section title
(
	'picktitle format',
	'[[Anchor(IntId.. %s)]]\n== %s ==\n',
	F1_stitle,
),
"term":	# definition list term
(
	"",
	"",
	"",
),
"word":	# in-text word enclosure
(
	'< >',
	'',
	'',
),
"keyword":	# keyword glossary enclosure
(
	'format < >',
	'[[Anchor(%s)]][[UndefinedKeyWord %s]]',
	F1_keyword,
),
"placer":	# NONE
(
	'',
	'',
	'',
),
"linkid":	# link ID
(
	'',
	'IntId',
	'',
),
"tableline":	# NONE
(
	'',
	'',
	'',
),
"tablercell":	# NONE
(
	'',
	'',
	'',
),
"llist":	# list 2nd level enclosure
(
	'',
	'',
	'',
),
"verb":	# verbatim enclosure
(
	'number format',
	"""
[[Anchor(%s)]]
{{{
%s}}}
||<tablestyle="text-align: center; width: 100%%">%s||

""",
	F1_verb,
),
"qsystem":	# system quoted enclosure
(
	'< >',
	'"{{{',
	'}}}"',
),
"llitem":	# list 2nd level item enclosure
(
	'',
	'\n    * ',
	'',
),
"sstitle":	# subsection title
(
	'picktitle',
	'=== ',
	' ===\n',
),
"nnnitem":	# enumeration 3rd level item enclosure
(
	'',
	'\n      1. ',
	'',
),
"tablelcell":	# NONE
(
	'',
	'',
	'',
),
"vbody":	# verbatim body
(
	"",
	"",
	"",
),
"footnote":	# footnote enclosure
(
	'format number >>',
	'[[Anchor(FootNoteAnchor%d)]][#FootNote%d (%d)]',
	F1_footnote,
),
"list":	# list 1st level enclosure
(
	'',
	'',
	'\n',
),
"otitle":	# object title
(
	"",
	"",
	"",
),
"emph":	# in-text emphasys enclosure
(
	'< >',
	"''",
	"''",
),
"eeenum":	# enumeration 3rd level enclosure
(
	'',
	'',
	'',
),
"ditem":	# definition list item enclosure
(
	'format',
	"\n'''%s'''\n  %s",
	F1_ditem,
),
"lllist":	# list 3rd level enclosure
(
	'',
	'',
	'',
),
"id":	# in-text ID
(
	'format',
	'[[Anchor(IntId%s)]]',
	F1_id,
),
"glossdef":	# glossary definition enclosure
(
	'',
	'\n||<tablewidth="90%">',
	'\n',
),
"lpunct":	# punctuation sign with left space
(
	"< ",
	"",
	"",
),
"npunct":	# punctuation sign without spaces
(
	"",
	"",
	"",
),
"normal":	# in-text word normal part
(
	'quote',
	'',
	'',
),
"glossitem":	# keyword glossary item
(
	'',
	'',
	'',
),
"sword":	# system word
(
	'',
	'',
	'',
),
"vtitle":	# verbatim title
(
	"",
	"",
	"",
),
"enum":	# enumeration 1st level enclosure
(
	'',
	'',
	'\n',
),
"eenum":	# enumeration 2nd level enclosure
(
	'',
	'',
	'',
),
"oid":	# object ID
(
	"format",
	"IntId%s",
	F1_oid,
),
"punct":	# punctuation sign
(
	'>',
	'',
	'',
),
"tablejcell":	# NONE
(
	'',
	'',
	'',
),
"nnitem":	# enumeration 2nd level item enclosure
(
	'',
	'\n    1. ',
	'',
),
"strong":	# strong enclosure
(
	'< >',
	"'''",
	"'''",
),
"ssect":	# subsection enclosure
(
	'',
	'\n',
	'',
),
"url":	# URL
(
	'',
	'',
	'',
),
"marktype":	# NONE
(
	'',
	'',
	'',
),
"mdash":	# Em-dash
(
	'< > nbsp',
	'',
	'--',
),
"object":	# object enclosure
(
	'number format',
	'[[Anchor(%s)]]\n||attachment:%s||\n||%s||\n',
	F1_object,
),
"srepl":	# system replaceable
(
	'',
	"}}}''{{{",
	"}}}''{{{",
),
"part":	# part enclosure
(
	'',
	'\n',
	'',
),
"ptitle":	# part title
(
	'picktitle format',
	'[[Anchor(IntId. %s)]]\n= %s =\n',
	F1_ptitle,
),
"sect":	# section enclosure
(
	'',
	'\n',
	'',
),
"inline":	# NONE
(
	'',
	'',
	'',
),
"tableccell":	# NONE
(
	'',
	'',
	'',
),
"nitem":	# enumeration 1st level item enclosure
(
	'',
	'\n  1. ',
	'',
),
}


class Writer(metalexer.Writer):
  def __init__(self, lexer):
    """metalexer.Writer.__init__"""
    metalexer.Writer.__init__(self,lexer)
    self.nbsp=" "		# TODO HTMLize
    self._pattern=".body."	# default to  fragment
    self._quote = [(metalexer.tpg.re.compile("'(.)"), r"~+\1+~"),]

  def pattern(self, title, divider):
    """Document to include generated text in
    first, replace the title"""
    patt=self._pattern.replace(".title.",title).replace("%","%%").replace(".body.","%s")
    return patt
  
  def genfootnotes(self):
    """Generate footnotes"""
    ret=[]
    for n in range(len(self.storage.get("footnote",[]))):
      #ret.append('<div><p class="footnote"><a class="footnotesym" name=".footnote%d" href="#.footanchor%d">%d</a>%s</p></div>\n'%(n+1,n+1,n+1,self.storage["footnote"][n]))
      ret.append('[[Anchor(FootNote%d)]][#FootNoteAnchor%d (%d)] %s\n'%(n+1,n+1,n+1,self.storage["footnote"][n]))
    return "\n".join(ret)

  formats={"moin":"moin", "*": "png" }

if __name__ == "__main__":
  import sys,mk_read
  R_mk=mk_read.Reader()
  result = R_mk(file(sys.argv[1]).read())
  writer = Writer(lexer)
  print writer(result)


