#!/usr/bin/env python
# -*- coding: koi8-r -*-

Type=("whtml",("whtml","wackohtml","WackoHtml"),"ALDC Wacko-ised HTML Reader",0.00,0.03)
import tpg
from ALDC import *
from HTMLParser import HTMLParser

class Dewacko(HTMLParser):

    def __init__(self):
      self.stack=[[],['m-k','m-k',{},[]]]
      self.trace=[]
      return HTMLParser.__init__(self)

    def auto(self, tag, attrs):
      alist=["html","body"]
      adict={}
      addict={"textarea": ("class","code","code")}
      if tag in alist: return tag
      if tag in adict: return adict[tag]
      if tag in addict and dict(attrs).get(addict[tag][0])==(addict[tag][1]):
	return addict[tag][2]
      # bother with attrs
      return "UNKNOWN"
      
    def handle_starttag(self, tag, attrs):
      attrd=dict(attrs)
      wack=attrd.pop("wacko",self.auto(tag,attrs))
      p=[wack,tag,attrd,[]]
      self.trace.append((p,0,self.stack[-1],self.trace and self.trace[-1] or None))
      self.stack.append(p)

    def handle_endtag(self, tag):
      if self.stack[-1][1] != tag:
	print "!!! WRONG tags %s <> %s"%(self.stack[-1][1],tag)
      p=self.stack.pop()
      self.stack[-1][-1].append(p)
      self.trace.append((p,1,self.stack[-1],self.trace[-1]))

    def handle_data(self, data):
      p=['_data','',{},data]
      self.stack[-1][-1].append(p)
      self.trace.append((p,0,self.stack[-1],self.trace[-1]))
      self.trace.append((p,1,self.stack[-1],self.trace[-1]))

    def __str__(self):
      def fmt(tree,sw=0):
	if not tree:
	  return ["-"]
	elif tree[0]=='_data':
	  return [".."*sw+str(tree[-1]).replace('\n',r'\n')]
	else:
	  return ["__"*sw+str(tree[0])+" | %s %s"%(tree[1],str(tree[2]))]+\
		reduce(list.__add__,[fmt(p,sw+1) for p in tree[-1]],[])
      return "\n".join(fmt(self.stack[-1]))

class Reader:
  dewacko=Dewacko()
  descr={}

  def __init__(self, *argp, **argn):
    pass

  def __call__(self, text):
    self.dewacko.feed(text)
    self.dewacko.close()
    #print self.dewacko
    #return self.aldize(self.dewacko.stack[1][3])
    print self.aldize()
    #print self.dewacko.stack[1]
    return ['m_k',['part',['ptitle',['word',['normal','QQ']]]]]

  def aldize(self):
    tree=self.dewacko.stack[1]
    chain=self.dewacko.trace
    curr=aldc=[]
    stack=[]
    for (wack, tag, attrs, content), closer, up, back in chain:
      if wack not in self.recode:
	self.recode[wack]='group UNKN'
      flags=self.recode[wack].split(' ')
      lwack=flags.pop(0)
      if closer:
	if wack !="_data":
	  if lwack:
	    curr=stack.pop()
      else:
	if wack=="_data":
	  if 'cr' not in oflags:
	    content=content.replace('\n','')
	  if content:
	    curr.append(content)
	else:
	  if lwack:
	    newtag=[lwack]
	    curr.append(newtag)
	    stack.append(curr)
	  else:
	    newtag=curr
	  curr=newtag
	  oflags=flags
    for k in self.recode:
      c=self.recode[k].split(' ')
      if "UNKN" in c:
	print "#\t'%s': '',\t# Undefiled tag"%k
    return str(aldc)

  recode={
  	'_data': '',
  	'html': 'm_k',
    	'body':	'',
	'br3':	'para 2 const',
	'italic': 'emph',
#	'h1': ['part', 'close'],
}
#	'add':	None,
#	'blockquote':	None,
#	'bold':	None,
#	'br':	None,
#	'br2':	None,
#	'br4':	None,
#	'center':	None,
#	'cite':	None,
#	'citecolor':	None,
#	'del':	None,
#	'dfn':	None,
#	'email':	None,
#	'escape':	None,
#	'fn1':	None,
#	'fn2':	None,
#	'formlink':	None,
#	'ftn2':	None,
#	'ftnd1':	None,
#	'h1':	None,
#	'h2':	None,
#	'h3':	None,
#	'h4':	None,
#	'h5':	None,
#	'h6':	None,
#	'hr':	None,
#	'href':	None,
#	'img':	None,
#	'indented':	None,
#	'italic':	None,
#	'mark':	None,
#	'monospace':	None,
#	'nameh1':	None,
#	'nameh2':	None,
#	'nameh3':	None,
#	'nameh4':	None,
#	'nameh5':	None,
#	'nameh6':	None,
#	'nli':	None,
#	'ol':	None,
#	'oli':	None,
#	'prelink':	None,
#	'small':	None,
#	'strike':	None,
#	'sub':	None,
#	'super':	None,
#	'table':	None,
#	'table2':	None,
#	'ul':	None,
#	'uli':	None,
#	'underlinue':	None,
#    }
